


library(mvtnorm)
library(naniar)
library(MASS)
library(stats)
library(fields)
library(parallel)

source("helpers.R")

n<-1000
B<-300
pval<-rep(NA, B)
set.seed(1)

#Process
c3<-0.314
c2<--c3
c4<-1.932
c1 <- -c4

n.cores=1

pval<-mclapply(1:B, function(b){
  
  cat(b)

  
  ## MAR Example taken from https://link.springer.com/content/pdf/10.1007/s11336-018-9609-x.pdf
  Z<-rmvnorm(n, Sigma=matrix( c(1,0,0,1), nrow=2,ncol=2 ))

  X<-Z
  X[,2] <- 0.5*Z[,1] + (1-0.5^2)^(0.5)*Z[,2]
  
  X.NA<-X
  X.NA[  ,2]<-ifelse( Z[,1] <= c1 | (Z[,1] > c2 &  Z[,1] <= c3)| Z[,1] > c4 , NA, X.NA[  ,2])
  

 return(bigTest(X = X.NA,
         num.proj=100,
         num.trees.per.proj = 200,
         nrep = 30,
         min.node.size=10,
         size.resp.set=1,
         refit=T))



}, mc.cores=n.cores)

save(pval,file="pvaltest.Rda")

# Power
mean(unlist(pval) < 0.05)











png(paste0("meanvarexampleillustration",".png"), width = 200, height = 200, units="mm",res = 300)


### Illustration

n<-10000


Z<-rmvnorm(n, Sigma=matrix( c(1,0,0,1), nrow=2,ncol=2 ))

# X<-Z
# X[,2] <- 0.5*Z[,1] + (1-0.5^2)^(0.5)*Z[,2]
# 
# X.NA<-X
# U<-runif(n)
# X.NA[  ,2]<-ifelse( U <= exp(Z[,2]-1)/(1+exp(Z[,2]-1)), NA, X.NA[  ,2])


X<-Z
X[,2] <- 0.5*Z[,1] + (1-0.5^2)^(0.5)*Z[,2]

X.NA<-X
X.NA[  ,2]<-ifelse( Z[,1] <= c1 | (Z[,1] > c2 &  Z[,1] <= c3)| Z[,1] > c4 , NA, X.NA[  ,2])


hist(X.NA[is.na(X.NA[,2]),1], main="", xlab = "", ylab="", xlim = c(-4,4), probability = T,cex.axis = 1.5)

dev.off()










