source("helpers.R")
library(latex2exp)

n<-500
p<-4

num.trees.per.proj <- 100
min.node.size <- 20
kind <- "mean"
size.resp.set <- 1
nrep=500
num.proj<-200

X<-matrix(rnorm(n=n*p), nrow=n, ncol=p)

# NA:

# MCAR in X[,2:p]

M <- genMask(X = X[,2:p], n = n, p = p-1, r = 0.65, type=  "MCAR")
Z.NA <- X[,2:p]
Z.NA[M==1] <- NA

Z.NA<-cbind(X[,1], Z.NA)

## first column is MAR
Z.NA[,1]<- sapply(1:nrow(Z.NA), function(j)   ifelse( mean(Z.NA[j,2], na.rm=T) > 0.5, NA, Z.NA[j,1]   ) )  # !any(is.na(Z.NA[j,]))     



pvals.bigTest <- bigTest(X = Z.NA,
                         num.proj,
                         num.trees.per.proj = num.trees.per.proj,
                         nrep = nrep,
                         compute.partial.pvals=TRUE,
                         min.node.size,
                         size.resp.set=size.resp.set)


pvals.bigTest


png(paste0("partialpvalexample",".png"), width = 600, height = 600)

# , main="First two components of the fully observed data"
par(mar=c(5,6,4,1)+.1)
plot(X[,1] , X[,2],pch=19,col="grey",cex=1,xlab = TeX('$X_1$'), ylab=TeX('$X_2$') ,cex.lab=1,font.lab=1,cex.main=1.5, cex.axis=1.5, cex.lab=2)
points(X[is.na(Z.NA[,1]),c(1,2)] , col="red", cex=1, pch=19)
points(X[is.na(Z.NA[,2]),c(1,2)] , col="blue", cex=1, pch=19)


dev.off()
