

# make sure the setwd() is where main_real.R lies.


source("../helpers.R")
library("parallel")
library("ranger")
library(mvtnorm)
library(naniar)
library(MASS)
library(stats)
library(fields)
library(mice)
require(data.table)
require(MASS)
require(snow)
require(ranger)
require(mlbench)
library(tidyverse)
require(gclus)
library(softImpute)
require(AER)
library(Matrix)
library(readxl)


n.cores <- 20

missing.mechs <- c("MAR","MCAR")
nsim <- 300
#r <- 0.35
num.proj <- 100
num.trees.per.proj <- 200
min.node.size <- 10
pmiss <- 0.3
nrep <- 30
level <- 0.05

refit <- TRUE

runEnergyTest <-FALSE  # This is always set to False, since the Q test is not included here.
runJJTest <- TRUE
runlittleTest <- TRUE


path0<-getwd()
setwd("..")
setwd("..")
datapath<-paste0(getwd(),"/DataSets")
setwd(path0)


n <- 100 #actually not needed
p <- 4 #actually not needed

kind <- "mean"
size.resp.set <- 2 #"random"
marmech <- "random"

index <- 7



if(runEnergyTest==TRUE){
   # with energy test (p<=10)
   datasets <- c("iris","seeds","glass", "yacht", "yeast", "concrete.compression",
               "airfoil", "blood.transfusion")
}else{
   # without energy test (p>10)
   datasets <- c("climate.model.crashes","ionosphere","planning.relax", "wine.quality.red", "wine.quality.white")
}

seed <- sample(c(0:2000),1)
set.seed(seed)

for (mech in missing.mechs){
  for (dataset in datasets){
    print(paste0(dataset))



  pvals <- runSims(nsim = nsim, type=mech,runEnergyTest=runEnergyTest,
                   runJJTest=runJJTest, runlittleTest=runlittleTest, case = dataset,
                   n = n, p = p, r = r,
                   num.proj = num.proj, num.trees.per.proj = num.trees.per.proj,
                   min.node.size = min.node.size, marmech = marmech,
                   level=level,nrep = nrep, n.cores=n.cores, kind=kind,
                   size.resp.set=size.resp.set, refit=refit,pmiss=pmiss, datapath=datapath)

  #print(paste("Case", case, "done"))

  filename = paste0("dataset_", dataset,
                    "_mech_", mech,
                    "_refit_",refit,
                    "_nrep_",nrep,
                    "_numproj_", num.proj,
                    "_nsim_",nsim,
                    "_level_",level,
                    "_minnodesize_", min.node.size,
                    "_numtreesperproj_", num.trees.per.proj,
                    "_size.resp.set_",size.resp.set,
                    "_kind_", kind
  )

    assign(filename, pvals)
    save(pvals, file=paste(filename, ".Rda",sep=""))


  }#, mc.cores = 1)

}



